<?php


require_once 'Privatkundenversand/PrivatkundenversandRequestBuilder.php';

//GrosskundenversandWS-Klassen werden mit __autoload() hinzugefuegt.
function __autoload($class_name) {
	global $pkvWSDir;
	if (file_exists($pkvWSDir . $class_name . '.php')) {
		require_once ($pkvWSDir . $class_name . '.php');
		return;
	}
}

echo "Programm wird gestartet..";

class PrivatkundenversandClient
{
	//Setzen sie die Zugangsdaten ueber /Einstellungen/zugangsdaten.ini
	private $cred_file_path = "./Einstellungen/zugangsdaten.ini";
	private $username_property_name = "benutzername";
	private $passwd_property_name = "passwort";
	private $partner_property_name = "marktplatzkennung";
	private $cred_array = null;
	private $USERNAME = "";
	private $PASSWD = "";
	private $PARTNERID = "";
	private $SUBPARTNERID = "";
	private $pkvRequestBuilder = null;
	private $pkvWSDir = "PrivatkundenversandWS/";


	function __construct() {
		$this->createDefaultCredentials();
		$this->USERNAME = $this->cred_array[$this->username_property_name];
		$this->PASSWD = $this->cred_array[$this->passwd_property_name];
		$this->PARTNERID = $this->cred_array[$this->partner_property_name];
		$this->pkvRequestBuilder = new PrivatkundenversandRequestBuilder();
	}


	public function createDefaultCredentials(){
		$this->cred_array = parse_ini_file($this->cred_file_path);
	}


	private function readMainMenuInput(){

		echo "Privatkundenversand Operationen: " . "\n" .
				"1 - ShoppingCartCheckoutViaPayment" . "\n" .
				"0 - Programm beenden" . "\n";
		echo "Waehlen Sie die gewuenschte Operation: ";
		$handle = fopen ("php://stdin","r");
		$line = fgets($handle);
		if(trim($line) == '0'){
			echo "Ende.\n";
			exit;
		} else {
			return $num = (int)$line;
		}
	}


	public function main(){
		$this->pkvRequestBuilder = new PrivatkundenversandRequestBuilder();
		$this->createDefaultCredentials();
		$this->USERNAME = $this->cred_array[$this->username_property_name];
		$this->PASSWD = $this->cred_array[$this->passwd_property_name];
		$this->PARTNERID = $this->cred_array[$this->partner_property_name];
		
		$auth = $this->pkvRequestBuilder->createAuthType($this->USERNAME, $this->PASSWD, $this->PARTNERID, $this->SUBPARTNERID);
		
		// Service-Stub erstellen
		$service = new PopPartnerService();

		try {
			$input = 0;
			do {
				$input = $this->readMainMenuInput();
				switch ($input) {
					case 1:
						$this->runShoppingCartCheckoutViaPayment($auth, $service);
						break;
				}
				if ($input != 0){
					echo 'Bitte, druecken Sie die Eingabe-Taste um fortzufahren.';
					$handle = fopen ("php://stdin","r");
					$line = fgets($handle);
				}
			} while ($input != 0);

		} catch (Exception $e) {
			echo $e;
		}
	}


	private function runShoppingCartCheckoutViaPayment($auth, $service){
		$sccvpRequest = $this->pkvRequestBuilder->getShoppingCartCheckoutViaPaymentRequestType($auth);
		$response = $service->shoppingCartCheckoutViaPayment($sccvpRequest);
// 		var_dump($response);
		$statusObj = $response->Status;
		
		if ($statusObj->status != 0){
			echo "Fehler: " . $statusObj->ErrorMessage;
		}else{
			$buyShCart = $response->BuyShoppingCart;
			$payFWShCart = $response->PaymentForwardShoppingCart;
			echo "\n Warenkorb ID: " . $buyShCart->shoppingCartId . "\n" . 
			"Weiterleitung (URL): " . $payFWShCart->paymentUrl;
		}
	}
}

$pkvClient = new PrivatkundenversandClient();
$pkvClient->main();