<?php

require_once 'Privatkundenversand/PrivatkundenversandWS/PopPartnerService.php';


class PrivatkundenversandRequestBuilder {

	private $DEFAULT_CART_ID = "DC6LNLQ9N";
	private $CART_VALIDATE_VERSION = '1.0.0';
	private $DEFAULT_PAYMENT_ID = "DUMMYPAYMENT";
	
	private $ORDERER_NAME1 = "Max Muster";
	private $ORDERER_NAME2 = "Muster Company";
	private $ORDERER_STREET = "Leipziger Stra�e";
	private $ORDERER_HOUSE_NR = "47";
	private $ORDERER_ZIP = "10117";
	private $ORDERER_CITY = "Berlin";
	private $ORDERER_COUNTRY_CODE = "DEU";
	private $ORDERER_EMAIL = "max@muster.de";
	private $ORDERER_PHONE = "+49 030 66447780";
	
	private $PROD_ID = "PAK10.DEU";
	
	private $SENDER_NAME1="Max Muster";
	private $SENDER_NAME2="Muster Company";
	private $SENDER_STREET="Leipziger Stra�e";
	private $SENDER_HOUSE_NR="47";
	private $SENDER_ZIP="10117";
	private $SENDER_CITY="Berlin";
	private $SENDER_COUNTRY_CODE="DEU";
	private $SENDER_EMAIL="max@muster.de";
	private $SENDER_PHONE="+49 030 66447780";
	
	private $RECEIVER_NAME1 = "Franz Klammer";
	private $RECEIVER_NAME2 = "Herr";
	private $RECEIVER_STREET = "Marktplatz";
	private $RECEIVER_HOUSE_NR = "1";
	private $RECEIVER_ZIP = "70173";
	private $RECEIVER_CITY = "Stuttgart";
	private $RECEIVER_COUNTRY_CODE = "DEU";
	private $RECEIVER_EMAIL = "franz@klammer.de";
	private $RECEIVER_PHONE = "+49 0711 544220";
	
	private $PAYMENT_ACCEPTED_URL="https://shoppingcart.partnerxy.de/a/b/c/PartnerDownloadgspt?accepted=true";
	private $PAYMENT_REJECTED_URL="https://shoppingcart.partnerxy.de/a/b/c/PartnerDownloadgspt?accepted=false";
	
	public function createAuthType($uname, $pass, $partnerId, $subpartnerId) {
		$auth = new AuthType();
		$auth->user=$uname;
		$auth->partnerId=$partnerId;
		$auth->subPartnerId=$subpartnerId;
		$auth->password=$pass;

		return $auth;
	}

	
	private function createDefaultDHLCheckout() {
		$dhlCheckout = new PaymentDHLCheckoutType();
		$dhlCheckout->PaymentId=$this->DEFAULT_PAYMENT_ID;
		return $dhlCheckout;
	}
	
	
	public function createDefaultOrderer() {
		$ordererAddr = new BaseLabelAddressType();
		$ordererAddr->name1=$this->ORDERER_NAME1;
		$ordererAddr->name2=$this->ORDERER_NAME2;
		$ordererAddr->street=utf8_encode($this->ORDERER_STREET);
		$ordererAddr->houseNumber=$this->ORDERER_HOUSE_NR;
		$ordererAddr->postalCode=$this->ORDERER_ZIP;
		$ordererAddr->city=$this->ORDERER_CITY;
		$ordererAddr->countryCode=$this->ORDERER_COUNTRY_CODE;
		$ordererAddr->email=$this->ORDERER_EMAIL;
		$ordererAddr->phoneNumber=$this->ORDERER_PHONE;
		return $ordererAddr;
	
	}
	
	
	public function createDefaultSenderAddress() {
		$senderAddr = new BaseLabelAddressType();
		$senderAddr->name1=$this->SENDER_NAME1;
		$senderAddr->name2=$this->SENDER_NAME2;
		$senderAddr->street=utf8_encode($this->SENDER_STREET);
		$senderAddr->houseNumber=$this->SENDER_HOUSE_NR;
		$senderAddr->postalCode=$this->SENDER_ZIP;
		$senderAddr->city=$this->SENDER_CITY;
		$senderAddr->countryCode=$this->SENDER_COUNTRY_CODE;
		$senderAddr->email=$this->SENDER_EMAIL;
		$senderAddr->phoneNumber=$this->SENDER_PHONE;
		return $senderAddr;	
	}
	
	
	public function createDefaultReceiverAddress() {
		$receiverAddr = new BaseLabelAddressType();
		$receiverAddr->name1=$this->RECEIVER_NAME1;
		$receiverAddr->name2=$this->RECEIVER_NAME2;
		$receiverAddr->street=$this->RECEIVER_STREET;
		$receiverAddr->houseNumber=$this->RECEIVER_HOUSE_NR;
		$receiverAddr->postalCode=$this->RECEIVER_ZIP;
		$receiverAddr->city=$this->RECEIVER_CITY;
		$receiverAddr->countryCode=$this->RECEIVER_COUNTRY_CODE;
		$receiverAddr->email=$this->RECEIVER_EMAIL;
		$receiverAddr->phoneNumber=$this->RECEIVER_PHONE;
		return $receiverAddr;
	}
	
	
	public function createDefaultItemType() {
		$lblItem = new LabelItemType();
		$lblItem->productId=$this->PROD_ID;
		$lblItem->SenderAddress=$this->createDefaultSenderAddress(); 
		$lblItem->ReceiverAddress=$this->createDefaultReceiverAddress();
		return $lblItem;
	}
	
	
	public function createDefaultBuyShoppingCart ($cartId){
		$shCart = new BuyShoppingCartType();
		$ShCartBaseType = new ShoppingCartBaseType();
		$shCart->acceptAgb=true;
		if (($cartId!="") or (null != $cartId))
			$shCart->shoppingCartId=$cartId;
		$shCart->PaymentDHLCheckout=$this->createDefaultDHLCheckout();
		$shCart->Orderer=$this->createDefaultOrderer();
		$shCart->LabelItem = $this->createDefaultItemType();
		return $shCart;
	}
	
	
	public function createDefaultPartnerBackLinks (){
	
		$pbl = new PartnerBackLinksType();
		$pbl->paymentAcceptedUrl = $this->PAYMENT_ACCEPTED_URL;
		$pbl->paymentRejectedUrl = $this->PAYMENT_REJECTED_URL;
		return $pbl;
	}
	
	
	public function getShoppingCartCheckoutViaPaymentRequestType($auth){
		$scpRequestType = new ShoppingCartCheckoutViaPaymentRequestType();
		$scpRequestType->Auth=$auth;
		$scpRequestType->BuyShoppingCart=$this->createDefaultBuyShoppingCart($this->DEFAULT_CART_ID);
		$scpRequestType->PartnerBackLinks=$this->createDefaultPartnerBackLinks();
		$scpRequestType->version=$this->CART_VALIDATE_VERSION;
		return $scpRequestType;
	}
	
}